Imports System
Imports System.IO
Imports System.Collections
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization.Formatters.Soap
Module Module1



    ' Attention : le namespace System.Runtime.Serialization.Formatters.Soap se trouve
    ' dans un assemblage du mme nom. Ajouter le en rfrence.

    <Serializable()> Public Class Rational
        Private m_numerator As Integer
        Private m_denominator As Integer

        Public Sub New(ByVal numerator As Integer, ByVal denominator As Integer)
            Me.m_numerator = numerator
            Me.m_denominator = denominator
        End Sub

        Public Overrides Function ToString() As String
            Return "[" & Me.m_numerator & "/" & Me.m_denominator & "]"
        End Function
    End Class

    Public Class Serialisation

        Public Shared Sub Load()
            Dim stream As FileStream = File.OpenRead("File.bin")

            Dim formatter As New BinaryFormatter()
            'Dim formatter As New SoapFormatter()

            Dim tb As ArrayList = CType(formatter.Deserialize(stream), ArrayList)
            Dim i As Integer
            For i = 0 To tb.Count - 1
                Console.Out.WriteLine(vbTab & tb(i).ToString())
            Next

            stream.Close()
        End Sub

        Public Shared Sub Save()
            Dim tb As New ArrayList()
            tb.Add("Ceci est une string")
            tb.Add(DateTime.Now)
            tb.Add(3.5)
            tb.Add(New Rational(3, 2))

            Dim stream As FileStream = File.Create("File.bin")

            Dim formatter As New BinaryFormatter()
            'Dim formatter As New SoapFormatter()

            formatter.Serialize(stream, tb)

            stream.Close()
        End Sub

        Public Shared Sub Main()
            While True
                Console.Out.Write("Entrez une commande : ")
                Dim command As String = Console.In.ReadLine()
                Select Case command
                    Case "exit"
                        Exit Sub
                    Case "load"
                        Load()
                    Case "save"
                        Save()
                End Select
            End While
        End Sub

    End Class


End Module
